@make(ais)
@aiInfo(topic=<Not all operations of a type are derivable>,
number=[AI-00393/00],
classcode=[ra],
statuscode=[RE],
mainref=[03.04@\(11)],
date=[85-10-06])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class ramification
!status received 85-10-06
@end(toplines)
@topic{!topic Not all operations of a type are derivable}
@end(history)

@subheading[!summary 85-10-06]


@subheading[!question 85-10-06]


@subheading[!response 85-10-06]


@begin(appendix)
@subheading[!appendix 85-09-26]
@begin(sectionGroup)
@mybar()

!section 03.04    (11) J. Goodenough 85-09-26                        83-00671
!version 1983
!topic Not all operations of a type are derivable
@end(sectionGroup)

One might think that all suprograms declared for a type in the visible part
of a package are derivable outside the package, but this is not the case.  A
pathological case exists in which certain implicitly declared subprograms
appear not to be derivable:

        package P1 is
             type T1 is new P.T;
             -- assume function F is derived here from P.T

             package P2 is
                  type T2 is range 1..10;
                  procedure G (X : T1; Y : T2);
             end P2;

             type T3 is new P2.T2;
             -- derives G (X : T1; Y : T3)
        end P1;

        type T4 is new P1.T1;
        -- G is not derived for T4

P1.G is an operation of type T1, but it is not derivable.  3.4(11) defines
two kinds of derivable subprograms: one kind must be declared explicitly, and
the other kind is declared implicitly by derivation.  G is clearly a
subprogram of the second kind.  The specific rule says:

        If  the  parent  type  is  itself  a  derived  type,  then  any
        subprogram that has been derived by this parent type is further
        derivable, unless the  parent type is  declared in the  visible
        part of a  package and the  derived subprogram is  hidden by  a
        derivable subprogram of the first kind.

G is not hidden by any declaration, so the part after the "unless" doesn't
apply.  The question is whether G is a subprogram "derived by" parent type
P1.T1.  The straightforward interpretation is that G is not derived "by" the
declaration of P1.T1, since it isn't implicitly declared after the
declaration of P1.T1.  Therefore, G is not a derivable subprogram.

Is this reasoning correct?

@end(appendix)
